#
# segatex SELinux tool.
#
# Copyright (C) 2007-2009 Shintaro Fujiwara 
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

#!/bin/sh
######this script basically echoes every lines in current directory recursively.
######this script echoes interface name and target domains.
INPUTFILE="interface_allow.txt"
OUTPUTFILE_PRE="target_domain_pre.txt"
OUTPUTFILE_PRE_NEXT="target_domain_pre_next.txt"
OUTPUTFILE_PRE_NEXT_2="target_domain_pre_next_2.txt"
OUTPUTFILE_PRE_NEXT_3="target_domain_pre_next_3.txt"
OUTPUTFILE="target_domain.txt"
INTERFACE_NAME=""
BRACE_LEFT="{"
BRACE_RIGHT="}"
BLANK=" "
TEMP_STR=
TEMP_STR2=
TEMP_STR3=
TEMP_STR4=

ECHO_LINES(){
	while read LINE
	do
		echo $LINE | grep "'$"
		TEMP_STR=`echo $LINE | grep "allow" | grep "[(.*)?_t]" | grep -v "self" | grep -v "filetye" | awk '{ print $3 }'| awk -F":" '{ print $1 }'`
		TEMP_STR2=`echo $LINE | grep "allow" | grep "[(.*)?_t]" | grep -v "self" | grep -v "filetye" | awk '{ print $4 }'| awk -F":" '{ print $1 }'`
		########### matches { a_t b_t c_t } ##################### 
		if [ "$TEMP_STR" = "$BRACE_LEFT" ]; then
			#echo $LINE | awk -F"{" '{ print $2 }' | awk -F"}" '{ print $1 }' | grep "[(.*)?_t]"
			echo $LINE | awk -F":" '{ print $1 }' | awk -F"{" '{ print $2 }' | awk -F"}" '{ print $1 }'
		else
			echo $TEMP_STR
		fi
		########### matches { { a_t b_t c_t } } ##################### 
		if [ "$TEMP_STR2" = "$BRACE_LEFT" ]; then
			#echo $LINE | awk -F":" '{ print $1 }' | awk -F"{" '{ print $3 }' | awk -F"}" '{ print $1 }'
			TEMP_STR3=`echo $LINE | awk -F":" '{ print $1 }' | awk -F"{" '{ print $3 }' | awk -F"}" '{ print $1 }'`
			TEMP_STR4=`echo $LINE | awk -F":" '{ print $1 }' | awk -F"{" '{ print $3 }' | awk -F"}" '{ print $2 }'`
			echo "$TEMP_STR3""$TEMP_STR4"
		else
			echo $TEMP_STR
		fi

	done < $INPUTFILE >> $OUTPUTFILE_PRE
}
rm $OUTPUTFILE_PRE
rm $OUTPUTFILE_PRE_NEXT
rm $OUTPUTFILE_PRE_NEXT_2
rm $OUTPUTFILE_PRE_NEXT_3
rm $OUTPUTFILE
ECHO_LINES
sed 's/$(.*)?_t//g' $OUTPUTFILE_PRE > $OUTPUTFILE_PRE_NEXT
sed 's/$[12]//g' $OUTPUTFILE_PRE_NEXT > $OUTPUTFILE_PRE_NEXT_2
sed 's/{//g' $OUTPUTFILE_PRE_NEXT_2 > $OUTPUTFILE_PRE_NEXT_3
sed '/^$/d' $OUTPUTFILE_PRE_NEXT_3 > $OUTPUTFILE
rm $OUTPUTFILE_PRE
rm $OUTPUTFILE_PRE_NEXT
rm $OUTPUTFILE_PRE_NEXT_2
rm $OUTPUTFILE_PRE_NEXT_3

exit 0
